#!/bin/sh
###############################################################
# Please edit the following lines to reflect the correct value
# for your system.
###############################################################

# Help

if [ $# -ge 1 ] && [ $1 = '-help' ]
then
    cat ../README
exit 1
fi
########################
#  PATHS - SETTINGS
#   (update as needed)

# JDK
# JAVA_HOME=/usr/lang/JAVA/jdk1.4

if [ -z "$JAVA_HOME" ]
then
	echo "Please set JAVA_HOME (JDK 1.4 or later) before launching the validator."
        exit 1
fi

JDMK_HOME=../../../

# resolve JDMK jars
if [ -z "$JDMK_HOME" ]
then
        echo "Please set JDMK_HOME (Java DMK install dir) before launching the validator."
        exit 1
fi

# resolve JAXP 1.2 jars
if [ -z "$JAXP12_ENDORSED" ]
then
        echo "Please set JAXP12_ENDORSED (jaxp/lib/endorsed dir from jwsdp 1.2 or later) before launching the validator."
        exit 1
    fi

VALIDATOR_HOME=..

##############
#Jar settings#
##############

# Jam jar file
validator_jar=$VALIDATOR_HOME/lib/mibvalidator.jar

# Jdmkrt jar file
jdmk_rt_jar=$JDMK_HOME/lib/jdmkrt.jar

# jmx jar
jmxri_jar=$JDMK_HOME/lib/jmx.jar
jmx_remote_jar=$JDMK_HOME/lib/jmxremote.jar
jmx_remote_oprional_jar=$JDMK_HOME]/lib/jmxremote_optional.jar
jmx_jar=${jmxri_jar}:${jmx_remote_jar}:${jmx_remote_oprional_jar}


##############
#Command Line#
##############

validation=
schema=$VALIDATOR_HOME/etc/mibvalidation.xsd

while [ $# -ge 2 ]; do
 case $1 in
   '-schema')
    schema=$2 ;;
   '-validation')
    validation=$2 ;;
   '-d')
    debug=$2 ;;
 esac
 shift
 shift
done

classpath=$validator_jar:$jmx_jar:$jdmk_rt_jar:$USER_CLASSPATH
###############################################################
echo Running mibvalidator...
if [ -z "$debug" ]
then
    $JAVA_HOME/bin/java -classpath ${classpath} -Djava.endorsed.dirs=$JAXP12_ENDORSED validator.Validator $schema $validation
else 
    $JAVA_HOME/bin/java -classpath ${classpath} -Djava.endorsed.dirs=$JAXP12_ENDORSED -DLEVEL_DEBUG -Djava.util.logging.config.file=../etc/logging.properties validator.Validator $schema $validation
fi
