/*
 * @(#)file      SnmpAddressFactory.java
 * @(#)author    Sun Microsystems, Inc.
 * @(#)version   1.4
 * @(#)date      04/07/05
 *
 * Copyright 2000-2004 Sun Microsystems, Inc.  All rights reserved.
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 * 
 * Copyright 2000-2004 Sun Microsystems, Inc.  Tous droits r?serv?s.
 * Ce logiciel est propriet? de Sun Microsystems, Inc.
 * Distribu? par des licences qui en restreignent l'utilisation. 
 *
 */
package com.sun.management.snmp.rfc2573.internal;

import  com.sun.management.snmp.rfc2573.target.SnmpAddress;

public class SnmpAddressFactory {
    private boolean testDomain(String domain) {
	if(domain.equals(SnmpIpDomainsAddress.UDP_DOMAIN) ||
	   domain.equals(SnmpIpDomainsAddress.TCP_DOMAIN) ||
	   domain.equals(SnmpIpDomainsAddress.UDP_DOMAIN_OID) ||	
	   domain.equals(SnmpIpDomainsAddress.TCP_DOMAIN_OID) ) 
	    return true;
	else return false;
    }
    
    public SnmpAddress createAddress(String domain, String address) throws Exception {
	if(testDomain(domain))
	    return new SnmpIpDomainsAddress(domain, address);
	else
	    return null;
    }
    
    public SnmpAddress createAddress(String domain, Byte[] address) throws Exception {
	if(testDomain(domain))
	    return new SnmpIpDomainsAddress(domain, address);
	else
	    return null;
    }
}
