/*
 * @(#)file      SnmpRfc2573Proxy.java
 * @(#)author    Sun Microsystems, Inc.
 * @(#)version   1.11
 * @(#)date      04/07/05
 *
 * Copyright 2000-2004 Sun Microsystems, Inc.  All rights reserved.
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 * 
 * Copyright 2000-2004 Sun Microsystems, Inc.  Tous droits r?serv?s.
 * Ce logiciel est propriet? de Sun Microsystems, Inc.
 * Distribu? par des licences qui en restreignent l'utilisation. 
 *
 */
package com.sun.management.snmp.rfc2573.internal.v3proxy;

import com.sun.management.snmp.agent.SnmpProxy;
import com.sun.jdmk.trace.Trace;
import com.sun.management.snmp.agent.SnmpMibRequest;

import com.sun.management.snmp.manager.SnmpParams;
import com.sun.management.snmp.manager.SnmpParameters;
import com.sun.management.snmp.SnmpEngine;
import com.sun.management.snmp.SnmpStatusException;

import com.sun.management.snmp.rfc2573.target.SnmpParamsData;
import com.sun.management.snmp.rfc2573.v3proxy.SnmpProxyData;
public class SnmpRfc2573Proxy extends SnmpProxy {
    SnmpProxyData data = null;
    private String dbgTag = "SnmpRfc2573Proxy";
    
    public SnmpRfc2573Proxy(SnmpProxyData data, SnmpEngine engine) throws SnmpStatusException {
	super(engine, data.singleOut.nonAuthoritativePeer, null, data.proxyName);
	this.data = data;
	try {
	    init();
	}catch(Exception e) {
	    throw new SnmpStatusException(e.getMessage());
	}	
	hideInvalidResponseError(false);
	if(isDebugOn()) {
	    debug("SnmpRfc2573Proxy", "Constructed");
	}
    }
    
    protected SnmpParams translateParameters(SnmpMibRequest req) {
	if(isDebugOn()) {
	    debug("translateParameters", " ");
	}
	if(isDebugOn()) {
	    debug("translateParameters", " Out params = " + data.singleOut.params);
	}
	SnmpParamsData out = data.singleOut.params;
	SnmpParameters ret = null;
	
	ret = new SnmpParameters();
	ret.setProtocolVersion(out.mpm);
	ret.setRdCommunity(out.securityName);
	ret.setWrCommunity(out.securityName);

	return ret;
    }

    private boolean isTraceOn() {
        return Trace.isSelected(Trace.LEVEL_TRACE, Trace.INFO_ADAPTOR_SNMP);
    }

    private void trace(String clz, String func, String info) {
        Trace.send(Trace.LEVEL_TRACE, Trace.INFO_ADAPTOR_SNMP, clz, func, info);
    }

    private void trace(String func, String info) {
        trace(dbgTag, func, info);
    }
    
    private boolean isDebugOn() {
        return Trace.isSelected(Trace.LEVEL_DEBUG, Trace.INFO_ADAPTOR_SNMP);
    }

    private void debug(String clz, String func, String info) {
        Trace.send(Trace.LEVEL_DEBUG, Trace.INFO_ADAPTOR_SNMP, clz, func, info);
    }

    private void debug(String func, String info) {
        debug(dbgTag, func, info);
    }

}
