package com.sun.management.snmp.rfc2573.v3proxy.mib;

//
// Generated by mibgen version 5.0 (03/20/02) when compiling SNMP-PROXY-MIB in standard metadata mode.
//

// java imports
//
import java.io.Serializable;

// jmx imports
//
import javax.management.MBeanServer;
import com.sun.management.snmp.SnmpCounter;
import com.sun.management.snmp.SnmpCounter64;
import com.sun.management.snmp.SnmpGauge;
import com.sun.management.snmp.SnmpInt;
import com.sun.management.snmp.SnmpUnsignedInt;
import com.sun.management.snmp.SnmpIpAddress;
import com.sun.management.snmp.SnmpTimeticks;
import com.sun.management.snmp.SnmpOpaque;
import com.sun.management.snmp.SnmpString;
import com.sun.management.snmp.SnmpStringFixed;
import com.sun.management.snmp.SnmpOid;
import com.sun.management.snmp.SnmpNull;
import com.sun.management.snmp.SnmpValue;
import com.sun.management.snmp.SnmpVarBind;
import com.sun.management.snmp.SnmpStatusException;

// jdmk imports
//
import com.sun.management.snmp.agent.SnmpMibNode;
import com.sun.management.snmp.agent.SnmpMib;
import com.sun.management.snmp.agent.SnmpMibEntry;
import com.sun.management.snmp.agent.SnmpStandardObjectServer;
import com.sun.management.snmp.agent.SnmpStandardMetaServer;
import com.sun.management.snmp.agent.SnmpMibSubRequest;
import com.sun.management.snmp.agent.SnmpMibTable;
import com.sun.management.snmp.EnumRowStatus;

/**
 * The class is used for representing SNMP metadata for the "SnmpProxyEntry" group.
 * The group is defined with the following oid: 1.3.6.1.6.3.14.1.2.1.
 */
public class SnmpProxyEntryMeta extends SnmpMibEntry implements Serializable, SnmpStandardMetaServer {

    /**
     * Constructor for the metadata associated to "SnmpProxyEntry".
     */
    public SnmpProxyEntryMeta(SnmpMib myMib, SnmpStandardObjectServer objserv) {
        objectserver = objserv;
        varList = new int[8];
        varList[0] = 9;
        varList[1] = 8;
        varList[2] = 7;
        varList[3] = 6;
        varList[4] = 5;
        varList[5] = 4;
        varList[6] = 3;
        varList[7] = 2;
        SnmpMibNode.sort(varList);
    }

    /**
     * Get the value of a scalar variable
     */
    public SnmpValue get(long var, Object data)
        throws SnmpStatusException {
        switch((int)var) {
            case 9:
                return new SnmpInt(node.getSnmpProxyRowStatus());

            case 8:
                return new SnmpInt(node.getSnmpProxyStorageType());

            case 7:
                return new SnmpString(node.getSnmpProxyMultipleTargetOut());

            case 6:
                return new SnmpString(node.getSnmpProxySingleTargetOut());

            case 5:
                return new SnmpString(node.getSnmpProxyTargetParamsIn());

            case 4:
                return new SnmpString(node.getSnmpProxyContextName());

            case 3:
                return new SnmpString(node.getSnmpProxyContextEngineID());

            case 2:
                return new SnmpInt(node.getSnmpProxyType());

            case 1:
                throw new SnmpStatusException(SnmpStatusException.noSuchInstance);
            default:
                break;
        }
        throw new SnmpStatusException(SnmpStatusException.noSuchObject);
    }

    /**
     * Set the value of a scalar variable
     */
    public SnmpValue set(SnmpValue x, long var, Object data)
        throws SnmpStatusException {
        switch((int)var) {
            case 9:
                if (x instanceof SnmpInt) {
                    try  {
                        node.setSnmpProxyRowStatus( new EnumSnmpProxyRowStatus (((SnmpInt)x).toInteger()));
                    } catch(IllegalArgumentException e)  {
                        throw new SnmpStatusException(SnmpStatusException.snmpRspWrongValue);
                    }
                    return new SnmpInt(node.getSnmpProxyRowStatus());
                } else {
                    throw new SnmpStatusException(SnmpStatusException.snmpRspWrongType);
                }

            case 8:
                if (x instanceof SnmpInt) {
                    try  {
                        node.setSnmpProxyStorageType( new EnumSnmpProxyStorageType (((SnmpInt)x).toInteger()));
                    } catch(IllegalArgumentException e)  {
                        throw new SnmpStatusException(SnmpStatusException.snmpRspWrongValue);
                    }
                    return new SnmpInt(node.getSnmpProxyStorageType());
                } else {
                    throw new SnmpStatusException(SnmpStatusException.snmpRspWrongType);
                }

            case 7:
                if (x instanceof SnmpString) {
                    node.setSnmpProxyMultipleTargetOut(((SnmpString)x).toByte());
                    return new SnmpString(node.getSnmpProxyMultipleTargetOut());
                } else {
                    throw new SnmpStatusException(SnmpStatusException.snmpRspWrongType);
                }

            case 6:
                if (x instanceof SnmpString) {
                    node.setSnmpProxySingleTargetOut(((SnmpString)x).toString());
                    return new SnmpString(node.getSnmpProxySingleTargetOut());
                } else {
                    throw new SnmpStatusException(SnmpStatusException.snmpRspWrongType);
                }

            case 5:
                if (x instanceof SnmpString) {
                    node.setSnmpProxyTargetParamsIn(((SnmpString)x).toString());
                    return new SnmpString(node.getSnmpProxyTargetParamsIn());
                } else {
                    throw new SnmpStatusException(SnmpStatusException.snmpRspWrongType);
                }

            case 4:
                if (x instanceof SnmpString) {
                    node.setSnmpProxyContextName(((SnmpString)x).toString());
                    return new SnmpString(node.getSnmpProxyContextName());
                } else {
                    throw new SnmpStatusException(SnmpStatusException.snmpRspWrongType);
                }

            case 3:
                if (x instanceof SnmpString) {
                    node.setSnmpProxyContextEngineID(((SnmpString)x).toByte());
                    return new SnmpString(node.getSnmpProxyContextEngineID());
                } else {
                    throw new SnmpStatusException(SnmpStatusException.snmpRspWrongType);
                }

            case 2:
                if (x instanceof SnmpInt) {
                    try  {
                        node.setSnmpProxyType( new EnumSnmpProxyType (((SnmpInt)x).toInteger()));
                    } catch(IllegalArgumentException e)  {
                        throw new SnmpStatusException(SnmpStatusException.snmpRspWrongValue);
                    }
                    return new SnmpInt(node.getSnmpProxyType());
                } else {
                    throw new SnmpStatusException(SnmpStatusException.snmpRspWrongType);
                }

            case 1:
                throw new SnmpStatusException(SnmpStatusException.snmpRspNotWritable);

            default:
                break;
        }
        throw new SnmpStatusException(SnmpStatusException.snmpRspNotWritable);
    }

    /**
     * Check the value of a scalar variable
     */
    public void check(SnmpValue x, long var, Object data)
        throws SnmpStatusException {
        switch((int) var) {
            case 9:
                if (x instanceof SnmpInt) {
                    try  {
                        node.checkSnmpProxyRowStatus( new EnumSnmpProxyRowStatus (((SnmpInt)x).toInteger()));
                    } catch(IllegalArgumentException e)  {
                        throw new SnmpStatusException(SnmpStatusException.snmpRspWrongValue);
                    }
                } else {
                    throw new SnmpStatusException(SnmpStatusException.snmpRspWrongType);
                }
                break;

            case 8:
                if (x instanceof SnmpInt) {
                    try  {
                        node.checkSnmpProxyStorageType( new EnumSnmpProxyStorageType (((SnmpInt)x).toInteger()));
                    } catch(IllegalArgumentException e)  {
                        throw new SnmpStatusException(SnmpStatusException.snmpRspWrongValue);
                    }
                } else {
                    throw new SnmpStatusException(SnmpStatusException.snmpRspWrongType);
                }
                break;

            case 7:
                if (x instanceof SnmpString) {
                    node.checkSnmpProxyMultipleTargetOut(((SnmpString)x).toByte());
                } else {
                    throw new SnmpStatusException(SnmpStatusException.snmpRspWrongType);
                }
                break;

            case 6:
                if (x instanceof SnmpString) {
                    node.checkSnmpProxySingleTargetOut(((SnmpString)x).toString());
                } else {
                    throw new SnmpStatusException(SnmpStatusException.snmpRspWrongType);
                }
                break;

            case 5:
                if (x instanceof SnmpString) {
                    node.checkSnmpProxyTargetParamsIn(((SnmpString)x).toString());
                } else {
                    throw new SnmpStatusException(SnmpStatusException.snmpRspWrongType);
                }
                break;

            case 4:
                if (x instanceof SnmpString) {
                    node.checkSnmpProxyContextName(((SnmpString)x).toString());
                } else {
                    throw new SnmpStatusException(SnmpStatusException.snmpRspWrongType);
                }
                break;

            case 3:
                if (x instanceof SnmpString) {
                    node.checkSnmpProxyContextEngineID(((SnmpString)x).toByte());
                } else {
                    throw new SnmpStatusException(SnmpStatusException.snmpRspWrongType);
                }
                break;

            case 2:
                if (x instanceof SnmpInt) {
                    try  {
                        node.checkSnmpProxyType( new EnumSnmpProxyType (((SnmpInt)x).toInteger()));
                    } catch(IllegalArgumentException e)  {
                        throw new SnmpStatusException(SnmpStatusException.snmpRspWrongValue);
                    }
                } else {
                    throw new SnmpStatusException(SnmpStatusException.snmpRspWrongType);
                }
                break;

            case 1:
                throw new SnmpStatusException(SnmpStatusException.snmpRspNotWritable);

            default:
                throw new SnmpStatusException(SnmpStatusException.snmpRspNotWritable);
        }
    }

    /**
     * Allow to bind the metadata description to a specific object.
     */
    protected void setInstance(SnmpProxyEntryMBean var) {
        node = var;
    }


    // ------------------------------------------------------------
    // 
    // Implements the "get" method defined in "SnmpMibEntry".
    // See the "SnmpMibEntry" Javadoc API for more details.
    // 
    // ------------------------------------------------------------

    public void get(SnmpMibSubRequest req, int depth)
        throws SnmpStatusException {
        objectserver.get(this,req,depth);
    }


    // ------------------------------------------------------------
    // 
    // Implements the "set" method defined in "SnmpMibEntry".
    // See the "SnmpMibEntry" Javadoc API for more details.
    // 
    // ------------------------------------------------------------

    public void set(SnmpMibSubRequest req, int depth)
        throws SnmpStatusException {
        objectserver.set(this,req,depth);
    }


    // ------------------------------------------------------------
    // 
    // Implements the "check" method defined in "SnmpMibEntry".
    // See the "SnmpMibEntry" Javadoc API for more details.
    // 
    // ------------------------------------------------------------

    public void check(SnmpMibSubRequest req, int depth)
        throws SnmpStatusException {
        objectserver.check(this,req,depth);
    }

    /**
     * Returns true if "arc" identifies a scalar object.
     */
    public boolean isVariable(long arc) {

        switch((int)arc) {
            case 9:
            case 8:
            case 7:
            case 6:
            case 5:
            case 4:
            case 3:
            case 2:
            case 1:
                return true;
            default:
                break;
        }
        return false;
    }

    /**
     * Returns true if "arc" identifies a readable scalar object.
     */
    public boolean isReadable(long arc) {

        switch((int)arc) {
            case 9:
            case 8:
            case 7:
            case 6:
            case 5:
            case 4:
            case 3:
            case 2:
                return true;
            default:
                break;
        }
        return false;
    }

    /**
     * Return the name of the attribute corresponding to the SNMP variable identified by "id".
     */
    public String getAttributeName(long id)
        throws SnmpStatusException {
        switch((int)id) {
            case 9:
                return "SnmpProxyRowStatus";

            case 8:
                return "SnmpProxyStorageType";

            case 7:
                return "SnmpProxyMultipleTargetOut";

            case 6:
                return "SnmpProxySingleTargetOut";

            case 5:
                return "SnmpProxyTargetParamsIn";

            case 4:
                return "SnmpProxyContextName";

            case 3:
                return "SnmpProxyContextEngineID";

            case 2:
                return "SnmpProxyType";

            case 1:
                return "SnmpProxyName";

            default:
                break;
        }
        throw new SnmpStatusException(SnmpStatusException.noSuchObject);
    }


    public  long getRowStatusId()  {
        return 9;
    }


    public  String getRowStatusName()  {
        return new String ("SnmpProxyRowStatus");
    }


    protected  int mapRowStatus(SnmpVarBind var, Object userData)
            throws SnmpStatusException {
        final SnmpValue value = var.getSnmpValue();
        if (value == null)
            throw new SnmpStatusException(
                SnmpStatusException.snmpRspInconsistentValue);
        if (!(value instanceof SnmpInt))
            throw new SnmpStatusException(
                SnmpStatusException.snmpRspWrongType);
        final int code = ((SnmpInt)value).intValue();
        if (!(EnumRowStatus.isValidValue(code)))
            throw new SnmpStatusException(
                SnmpStatusException.snmpRspInconsistentValue);
        return  code;
    }


    public  int getRowStatus(Object userData)
            throws SnmpStatusException {
        final  SnmpValue x = get(9, userData);
        final  SnmpVarBind vb = new SnmpVarBind();

        // We know we won't need the OID.
        //
        // vb.oid = new SnmpOid("1.3.6.1.6.3.14.1.2.1.9");

        vb.setSnmpValue(x);
        return mapRowStatus(vb, userData);
    }


    public  SnmpValue setRowStatus(int status, Object userData)
            throws SnmpStatusException {
        final  SnmpInt x = new SnmpInt(status);
        return  set(x, 9, userData);
    }


    public  boolean isRowReady(Object userData)
            throws SnmpStatusException {
        
        // A default implementation could be for instance:
        // return 	(getRowStatus(userData) != EnumRowStatus.notReady);
        
        return true;
    }

    protected SnmpProxyEntryMBean node;
    protected SnmpStandardObjectServer objectserver = null;
}
